Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReserveEntry/FrmMaterialReserveEntry.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReserveEntry/FrmMaterialReserveEntry.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialReserveEntry/FrmMaterialReserveEntry.cs	(revision 51)
@@ -0,0 +1,1594 @@
+using System;
+using System.Collections.Generic;
+using System.Collections;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Linq;
+using System.Diagnostics;
+using System.Threading;
+using System.Text.RegularExpressions;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.Master;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+//*------------------------ 単位マスタメンテ画面 ----------------------*
+//  2015/07/14  Ver1.0.0.0      Create Source           
+//
+//
+//
+//*----------------------------------------------------------------------------*
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmMaterialReserveEntry : Form
+    {
+        #region グリッド並び替え
+        private class RowComparer : System.Collections.IComparer
+        {
+            private static int sortOrderModifier = 1;
+
+            public RowComparer()
+            {
+            }
+
+            public int Compare(object x, object y)
+            {
+                DataGridViewRow DataGridViewRow1 = (DataGridViewRow)x;
+                DataGridViewRow DataGridViewRow2 = (DataGridViewRow)y;
+
+                int CompareResult = System.String.Compare(
+                    DataGridViewRow1.Cells[(int)DispColumn.MaterialKindDisplayOrder].Value.ToString(),
+                    DataGridViewRow2.Cells[(int)DispColumn.MaterialKindDisplayOrder].Value.ToString());
+
+                if (CompareResult == 0)
+                {
+                    CompareResult = System.String.Compare(
+                        DataGridViewRow1.Cells[(int)DispColumn.MaterialItemDisplayOrder].Value.ToString(),
+                        DataGridViewRow2.Cells[(int)DispColumn.MaterialItemDisplayOrder].Value.ToString());
+                }
+                return CompareResult * sortOrderModifier;
+            }
+        }
+
+
+        #endregion
+
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示カラム
+        /// </summary>
+        private enum DispColumn
+        {
+            RowState = 0,
+            DisplayOrder,
+            MaterialKindCode,
+            MaterialKindName,
+            MaterialKindDisplayOrder,
+            MaterialItemCode,
+            MaterialItemName,
+            MaterialItemDisplayOrder,
+            RentCount,
+            MaterialCount,
+            MaterialCountBefore,
+            RepayPlanDate,
+            CommentText,
+        }
+
+        private enum DataColumn
+        {
+            MaterialKindCode = 0,
+            MaterialKindName,
+            MaterialKindDisplayOrder,
+            MaterialItemCode,
+            MaterialItemName,
+            MaterialItemDisplayOrder,
+            RentCount,
+            MaterialCount,
+            RepayPlanDate,
+            CommentText,
+        }
+        /// <summary>
+        /// マスタリストMAXライン
+        /// </summary>
+        //private const int s_ListMaxLineCount = 53;
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// フィールド値変化フラグ
+        /// </summary>
+        private bool m_bChengeAns = false;
+
+        /// <summary>
+        /// ダイアログ使用フラグ
+        /// </summary>
+        private bool m_DialogFlg = false;
+
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        private int m_ConstructionCode = 0;
+        /// <summary>
+        /// 終了ボタン押下フラグ
+        /// </summary>
+        private bool m_EndButton = false;
+
+        /// <summary>
+        /// データ操作
+        /// </summary>
+        private IOMaterialInfo m_IoMi = null;
+
+        /// <summary>
+        /// 貸出日変更前値
+        /// </summary>
+        private string m_ProcessPrev = "";
+
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        private bool m_EditLock = false;
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        private bool m_SubForm = false;
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        private bool m_ParentEnd = false;
+        // *-----* 共通処理設定 *-----*
+
+        private bool m_CloseingProcessOn = false;
+        
+        #endregion
+
+        #region コンストラクタ
+        public FrmMaterialReserveEntry()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        #region デストラクタ
+        ~FrmMaterialReserveEntry()
+        {
+            try
+            {
+                GC.Collect();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+
+        #region プロパティ
+        /// <summary>
+        /// ダイアログ使用時フラグ
+        /// </summary>
+        public bool DialogUsed
+        {
+            set { m_DialogFlg = value; }
+        }
+        /// <summary>
+        /// 工事番号
+        /// </summary>
+        public int ConstructionCode
+        {
+            get { return m_ConstructionCode; }
+            set { m_ConstructionCode = value; }
+
+        }
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        public bool EditLock
+        {
+            get { return m_EditLock; }
+            set { m_EditLock = value; }
+        }
+
+        // *-----* 共通処理設定 *-----*
+        /// <summary>
+        /// サブフォームフラグ
+        /// </summary>
+        public bool SubForm
+        {
+            get { return m_SubForm; }
+            set { m_SubForm = value; }
+        }
+        /// <summary>
+        /// 呼出元終了フラグ
+        /// </summary>
+        public bool ParentEnd
+        {
+            get { return m_ParentEnd; }
+            set { m_ParentEnd = value; }
+        }
+        // *-----* 共通処理設定 *-----*
+
+        #endregion
+
+
+        #region イベントメソッド
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReserveEntry_FormClosing(object sender, FormClosingEventArgs e)
+        {
+            try
+            {
+                if (m_EndButton) return;
+                if (m_bChengeAns)
+                {
+                    if (MessageBox.Show("データに変更があります、登録せずに終了してよろしいですか？。", "終了確認"
+                                    , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                    {
+                        e.Cancel = true;
+                        return;
+                    }
+                }
+                // 前プロセスに戻る
+                ClsExcute.BackProcess();
+
+            }
+            finally
+            {
+                // ロック解除用
+                if (e.Cancel != true && m_IoMi != null)
+                {
+                    m_IoMi.rollback();
+                    m_IoMi.close();
+                    m_IoMi = null;
+                }
+
+            }
+        }
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            this.Close();
+        }
+
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReserveEntry_Load(object sender, EventArgs e)
+        {
+
+            // ロックを実行する為
+            try
+            {
+                m_IoMi = new IOMaterialInfo();
+                m_IoMi.connect();
+                m_IoMi.SetLockWaitime(1);
+                m_IoMi.beginTran();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                this.Close();
+            }
+
+            if(m_EditLock) btnDataEntry.Enabled = false;
+
+            // 初期表示
+            InitDataLoad();
+            
+            // ダイアログ使用時
+            if (m_DialogFlg)
+            {
+                //フォームの幅だけを変更する
+                this.SetBounds(this.Left, this.Top, (this.Width - 40), this.Height, BoundsSpecified.Width);
+            }
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+
+            // ボタン表示の制御
+            ButtonVisble(this);
+
+            // *-----* 処理移動ボタン設定 *-----*
+            CreateProcessContextMenu(m_SubForm);
+            // *-----* 処理移動ボタン設定 *-----*
+
+        }
+
+        /// <summary>
+        /// 行データクリア
+        /// </summary>
+        /// <param name="iIndex">行カウント</param>
+        private void SetRowClearData(int iIndex)
+        {
+            // クリアデータセット
+        }
+
+        /// <summary>
+        /// グリッド採番処理
+        /// </summary>
+        private void LineReNumbering()
+        {
+            int icnt = 1;
+            foreach (DataGridViewRow r in dgvMaster.Rows)
+            {
+                // 表示されているものだけ採番
+                if (r.Visible)
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = (icnt++).ToString();
+                else
+                    r.Cells[(int)DispColumn.DisplayOrder].Value = "0";
+            }
+        }
+        /// <summary>
+        /// 行追加ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineEntry_Click(object sender, EventArgs e)
+        {
+            // 行がない場合は作成して抜ける
+            if (dgvMaster.Rows.Count == 0)
+            {
+                if (MessageBox.Show("行を追加します", "追加確認"
+                                    , MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == DialogResult.Cancel) return;
+
+                // 行追加
+                dgvMaster.Rows.Add();
+                // クリアデータセット
+                SetRowClearData(0);
+                // №再採番
+                LineReNumbering();
+                //　変更フラグOn
+                valueChange(sender, e);
+                // フォーカス移動
+                dgvMaster.Focus();
+                return;
+            }
+
+            // メッセージ表示
+            BtnTextCustomMessageBox msg = new BtnTextCustomMessageBox();
+            msg.ButtonText.No = "前へ追加";
+            msg.ButtonText.Yes = "後へ追加";
+            msg.ButtonText.Cancel = "キャンセル";
+            DialogResult resRet = msg.Show("行の前・後を選択してください。", "追加確認"
+                                            , MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information);
+
+            // キャンセルは処理しない
+            if (resRet == DialogResult.Cancel) return;
+
+            // カレント行取得
+            int iIndex = dgvMaster.CurrentRow.Index;
+            // 最終行
+            if (iIndex == dgvMaster.RowCount - 1)
+            {
+                if (resRet == DialogResult.No)
+                {
+                    // 前
+                    dgvMaster.Rows.Insert(iIndex);
+                }
+                else if (resRet == DialogResult.Yes)
+                {
+                    // 後
+                    dgvMaster.Rows.Add();
+                    iIndex = (dgvMaster.RowCount - 1);
+                }
+            }
+            else
+            {
+                if (resRet == DialogResult.Yes)
+                {
+                    // 後ろ
+                    ++iIndex;
+                }
+                dgvMaster.Rows.Insert(iIndex);
+            }
+
+            // クリアデータセット
+            SetRowClearData(iIndex);
+
+            // №再採番
+            LineReNumbering();
+
+            //　変更フラグOn
+            valueChange(sender, e);
+
+            // フォーカス移動
+            dgvMaster.Focus();
+            //dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+            //dgvMaster.CurrentCell = dgvMaster[0, iIndex];
+        }
+
+        /// <summary>
+        /// フィールド値変更フラグ
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void valueChange(object sender, EventArgs e)
+        {
+            m_bChengeAns = true;
+        }
+
+        /// <summary>
+        /// セル値変化
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            
+            // インデックス外は処理しない
+            if (e.RowIndex < 0 || e.ColumnIndex < 0) return;
+            // null値は処理しない
+            if (dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].Value == null) return;
+
+            // 値が変わればツールチップを変更する
+            dgvMaster.Rows[e.RowIndex].Cells[e.ColumnIndex].ToolTipText
+                = CommonMotions.cnvString(((DataGridView)sender).Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
+            // 変更フラグON
+            m_bChengeAns = true;
+        }
+                /// <summary>
+        /// 行削除ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnLineDelete_Click(object sender, EventArgs e)
+        {
+            IOMUnit uDB = new IOMUnit();
+
+            try
+            {
+                //if (CommonMotions.chkCellBlank(dgvMaster.CurrentRow.Cells[(int)DispColumn.NameString].Value)) return;
+
+                if (MessageBox.Show("選択した行データを削除します。", "削除確認"
+                    , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return;
+
+                // 表示行退避
+                int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                uDB.connect();
+                uDB.beginTran();
+
+                string strSQL = uDB.CreatePrimarykeyString(CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemName].Value));
+                if (!uDB.DeleteAction(strSQL, false))
+                {
+                    uDB.rollback();
+                    MessageBox.Show("削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                uDB.commit();
+
+                // データ表示
+                if (!DispGridData()) return;
+
+                // 表示行復元
+                dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+                // 変更フラグOff
+                m_bChengeAns = false;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                uDB.close();
+                uDB = null;
+            }
+        }
+
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataEntry_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return;
+
+                if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+
+                // 表示行退避
+                int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+                // データ登録
+                if (!DataEntry()) return;
+
+                m_bChengeAns = false;
+                LoadComboBox();
+
+                this.Refresh();
+
+                // データ表示
+                if (!DispGridData()) return;
+
+                // 表示行復元
+                dgvMaster.FirstDisplayedScrollingRowIndex = iIndex;
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// IMEのコントロール
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //列によってIMEのモードを変更する
+                if (dgv.Columns[e.ColumnIndex].Name.Equals("Column3"))
+                {
+                    dgv.ImeMode = ImeMode.On;
+                }
+                else
+                {
+                    dgv.ImeMode = ImeMode.Disable;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+
+        /// <summary>
+        /// セルダブルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
+        {
+            // ダイアログとして使用するとき以外は処理しない
+            if (!m_DialogFlg) return;
+
+            if (e.RowIndex < 0) return;
+
+            btnEnd_Click(sender, (EventArgs)e);
+        }
+
+        /// <summary>
+        /// Formキーダウン処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialReserveEntry_KeyDown(object sender, KeyEventArgs e)
+        {
+            // DataGridviewは処理しない
+            if (ActiveControl.Name.Equals("dgvMaster"))
+            {
+                return;
+            }
+        }
+
+        #endregion
+
+        #region プライベートメソッド
+        /// <summary>
+        /// コンボボックスのロード
+        /// </summary>
+        private void LoadComboBox()
+        {
+            IOMaterialRecordInfo IoMri = new IOMaterialRecordInfo();
+            List<KeyValuePair<string, string>> DataList;
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                if (ConstructionCode == 0) return;
+
+                if (!IoMri.ExecuteReader(string.Format("select DATE_FORMAT(ProcessDate, '%Y/%m/%d') from MaterialRecordInfo where ConstructionCode = {0} and RECKIND = 0 group by ProcessDate order by ProcessDate desc", ConstructionCode), ref arData)) return;
+
+                DataList = new List<KeyValuePair<string, string>>();
+                if (arData.Count == 0)
+                {
+                    DataList.Add(new KeyValuePair<string, string>("0", "新規"));
+                }
+                // データ表示
+                int cnt = 0;
+                foreach (object[] work in arData)
+                {
+                    if (cnt == 0 && CommonMotions.cnvString(work[0]) != DateTime.Now.Date.ToString("yyyy/MM/dd"))
+                    {
+                        DataList.Add(new KeyValuePair<string, string>("0", "新規"));
+                    }
+                    KeyValuePair<string, string> keyval = new KeyValuePair<string, string>(CommonMotions.cnvString(work[0]), CommonMotions.cnvString(work[0]));
+
+                    DataList.Add(keyval);
+                    cnt++;
+                }
+
+                // コンボボックス初期表示
+                cmbProcessDate.DataSource = null;
+                cmbProcessDate.ValueMember = "Key";
+                cmbProcessDate.DisplayMember = "Value";
+                ComboBoxAction.InitDataSetCombBox(cmbProcessDate, DataList, false);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoMri.close();
+                IoMri = null;
+            }
+        }
+
+
+
+
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            IOConstructionBaseInfoDetail IoConB = new IOConstructionBaseInfoDetail();
+            ConstructionBaseInfoDetail ConB = new ConstructionBaseInfoDetail();
+            try
+            {
+
+
+                //テスト用工事番号
+                //ConstructionCode = 2016020201;
+
+                // 画面表示用データ取得
+                if (!IoConB.SelectAction(string.Format(" where ConstructionCode = {0} and DETAILNO = 2", ConstructionCode), ref ConB)) return ;
+
+                lblDETAILSTRING.Text = ConB.DetailString;
+
+                // 担当にログインユーザー名を表示
+                lblPerson.Text = CommonMotions.LoginUserData.PersonName;
+
+                // コンボボックス設定
+                LoadComboBox();
+
+                // ダイアログ使用時
+                if (m_DialogFlg)
+                {
+                    label1.Text = "単位マスタ検索一覧";
+                }
+
+                m_bChengeAns = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            bool bAns = true;
+            string sErrmsg = "";
+            int errorCol = 0;
+            try
+            {
+
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    CommonMotions.chgBackColor(r.Cells[(int)DispColumn.MaterialCount], true);
+                    CommonMotions.chgBackColor(r.Cells[(int)DispColumn.RepayPlanDate], true);
+                    CommonMotions.chgBackColor(r.Cells[(int)DispColumn.CommentText], true);
+                }
+
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    //
+                    bAns = true;
+                    if (CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCount].Value) == 0)
+                    {
+                        bAns = false;
+                        sErrmsg = "貸出数が入力されていません。";
+                        errorCol = (int)DispColumn.MaterialCount;
+                    }
+
+                    Regex regex = new Regex(@"^[0-9]+$");
+                    Match match = regex.Match(r.Cells[(int)DispColumn.MaterialCount].Value.ToString());
+                    if (!match.Success)
+                    {
+                        bAns = false;
+                        sErrmsg = "１以上の整数を入力してください。";
+                        errorCol = (int)DispColumn.MaterialCount;
+                    }
+
+                    // 背景色変更
+                    CommonMotions.chgBackColor(r.Cells[errorCol], bAns);
+
+                    DateTime dt;
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.RepayPlanDate].Value).Length == 0)
+                    {
+                        bAns = false;
+                        sErrmsg = "データが入力されていません、確認してください。";
+                        errorCol = (int)DispColumn.RepayPlanDate;
+                    }
+                    regex = new Regex(@"^(\d{4})/(0[1-9]|1[0-2])/(0[1-9]|[12][0-9]|3[01])$");
+                    match = regex.Match(CommonMotions.cnvString(r.Cells[(int)DispColumn.RepayPlanDate].Value));
+                    if(!match.Success)
+                    {
+                        bAns = false;
+                        sErrmsg = "日付のフォーマットが不正です。(YYYY/MM/DD形式で入力してください)";
+                        errorCol = (int)DispColumn.RepayPlanDate;
+                    }
+                    else if (!DateTime.TryParse(CommonMotions.cnvString(r.Cells[(int)DispColumn.RepayPlanDate].Value), out dt))
+                    {
+                        bAns = false;
+                        sErrmsg = "日付のフォーマットが不正です。";
+                        errorCol = (int)DispColumn.RepayPlanDate;
+                    }
+                    else if (dt.Date <= DateTime.Now.Date)
+                    {                    
+                        bAns = false;
+                        sErrmsg = "返却予定日には、当日以前は設定できません。";
+                        errorCol = (int)DispColumn.RepayPlanDate;
+                    }
+
+                    // 背景色変更
+                    CommonMotions.chgBackColor(r.Cells[errorCol], bAns);
+
+                    if (CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value) != "")
+                    {
+                        // レングスチェック
+                        int len = Encoding.GetEncoding("Shift_JIS").GetByteCount(CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value));
+                        if (len > 80)
+                        {
+                            bAns = false;
+                            sErrmsg = "入力エラーがあります、確認してください。";
+                            errorCol = (int)DispColumn.CommentText;
+                        }
+                    }
+
+                    // 背景色変更
+                    CommonMotions.chgBackColor(r.Cells[errorCol], bAns);
+                    bRet &= bAns;
+
+                }
+
+                if (!bRet)
+                {
+                    MessageBox.Show(sErrmsg, "データ確認"
+                                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                }
+
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+      }
+
+        /// <summary>
+        /// データ登録
+        /// </summary>
+        private bool DataEntry()
+        {
+
+            IOMaterialRecordInfo IoMri = new IOMaterialRecordInfo();
+            IOConstructionMaterialInfo IoCmi = new IOConstructionMaterialInfo();
+
+            MaterialInfo MiWork;
+            ConstructionMaterialInfo CmiWork;
+            MaterialRecordInfo MriWork;
+
+            List<ConstructionMaterialInfo> CmiList;
+            List<MaterialRecordInfo> MriList;
+
+            try
+            {
+
+                DataRowState CmiState = DataRowState.Unchanged;
+                DataRowState MriState = DataRowState.Unchanged;
+
+                // 貸出日指定
+                string strProcessdate = cmbProcessDate.SelectedValue.ToString() == "0" ?
+                                        DateTime.Now.Date.ToString("yyyy/MM/dd") : cmbProcessDate.SelectedValue.ToString();
+
+                IoMri.connect();
+                IoMri.beginTran();
+
+                IoCmi.connect();
+                IoCmi.beginTran();
+
+                foreach (DataGridViewRow r in dgvMaster.Rows)
+                {
+                    bool bProcessNoToday = false;
+                    MiWork = new MaterialInfo();
+                    CmiWork = new ConstructionMaterialInfo();
+                    MriWork = new MaterialRecordInfo();
+
+                    CmiList = new List<ConstructionMaterialInfo>();
+                    MriList = new List<MaterialRecordInfo>();
+
+                    int intMaterialItemCode = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialItemCode].Value);
+                    int intRentCount= CommonMotions.cnvInt(r.Cells[(int)DispColumn.RentCount].Value);
+                    int intMaterialCount = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCount].Value);
+                    int intMaterialCountBefore = CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCountBefore].Value);
+
+                    ArrayList arData = new ArrayList();
+                    // 当日以外のデータが存在するか調査
+                    string sql = string.Format("select ProcessDate from MaterialRecordInfo where ProcessDate <> DATE_FORMAT('{0}','%Y/%m/%d') and ConstructionCode = {1} and MaterialItemCode = {2} and RECKIND = 0 group by ProcessDate", strProcessdate, m_ConstructionCode, intMaterialItemCode);
+                    IoMri.ExecuteReader(sql, ref arData,false);
+                    if (arData.Count != 0) bProcessNoToday = true;
+
+                    // 資材情報
+                    string strSQL = m_IoMi.CreatePrimarykeyString(intMaterialItemCode);
+                    List<MaterialInfo> MiList = new List<MaterialInfo>();
+                    if (!m_IoMi.SelectAction(strSQL, ref MiList, false))
+                    {
+                        MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+
+                    // 更新ロック
+                    m_IoMi.rollback();
+                    if (!m_IoMi.RowLockUpdate(intMaterialItemCode, false))
+                    {
+                        m_IoMi.RowLockShare(intMaterialItemCode, false);
+                        MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                    // 登録チェック②－２
+                    if ((MiList[0].RentCount + CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCountBefore].Value)) < CommonMotions.cnvInt(r.Cells[(int)DispColumn.MaterialCount].Value))
+                    {
+                        m_IoMi.rollback();
+                        m_IoMi.RowLockShare(intMaterialItemCode, false);
+                        MessageBox.Show("割当可能数を超えて、資材の予約できません。", "登録エラー"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+
+                    // 解除時は前貸出数を加算
+                    MiWork.MaterialCount = MiList[0].MaterialCount;
+                    if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Deleted)
+                    {
+                        MiWork.RentCount = intRentCount + intMaterialCountBefore;
+                    }
+                    else
+                    {
+                        MiWork.RentCount = (intRentCount + intMaterialCountBefore) - intMaterialCount;
+                    }
+                    MiWork.DeleteFlg = MiList[0].DeleteFlg;
+
+                    // データ登録
+                    if (!m_IoMi.UpdateAction(strSQL, MiWork, false))
+                    {
+                        m_IoMi.rollback();
+                        m_IoMi.RowLockShare(intMaterialItemCode, false);
+                        MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+
+                    // データ操作内容設定
+                    if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Added)
+                    {
+                        if (bProcessNoToday == false)        // 登録時のDB登録について　１
+                        {
+                            CmiState = DataRowState.Added;
+                            MriState = DataRowState.Added;
+
+                        }
+                        else if (bProcessNoToday == true)   // 登録時のDB登録について　２
+                        {
+                            CmiState = DataRowState.Modified;
+                            MriState = DataRowState.Added;
+                        }
+                    }
+                    else if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Unchanged)   
+                    {
+                        // 登録時のDB登録について　３、４
+                        CmiState = DataRowState.Modified;
+                        MriState = DataRowState.Modified;
+                    }
+                    else if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Deleted)
+                    {
+                        if (bProcessNoToday == false)        // 登録時のDB登録について　５
+                        {
+                            CmiState = DataRowState.Deleted;
+                            MriState = DataRowState.Deleted;
+                        }
+                        else if (bProcessNoToday == true)   // 登録時のDB登録について　６
+                        {
+                            CmiState = DataRowState.Modified;
+                            MriState = DataRowState.Deleted;
+                        }
+                    }
+
+
+                    //  工事資材情報
+                    CmiWork.ConstructionCode = m_ConstructionCode;
+                    CmiWork.MaterialItemCode = intMaterialItemCode;
+                    CmiWork.CompleteFlg = 0;
+
+                    if (CmiState == DataRowState.Added) // 工事資材情報 新規
+                    {
+                        CmiWork.RentCount = intMaterialCount;
+                        CmiWork.RepayCount = 0;
+
+                        CmiList.Clear();
+                        CmiList.Add(CmiWork);
+                        // データ登録
+                        if (!IoCmi.InsertAction(CmiList, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            IoCmi.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+
+                    }
+                    else if (CmiState == DataRowState.Modified || CmiState == DataRowState.Deleted) // 工事資材情報 更新or削除
+                    {
+                        // 工事資材情報　
+                        strSQL = IoCmi.CreatePrimarykeyString(m_ConstructionCode, intMaterialItemCode);
+                        if (!IoCmi.SelectAction(strSQL, ref CmiList, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+
+                        // 解除時は前貸出数を減算
+                        if ((DataRowState)r.Cells[(int)DispColumn.RowState].Value == DataRowState.Deleted)
+                        {
+                            CmiWork.RentCount = (CmiList[0].RentCount - intMaterialCountBefore);
+                        }
+                        else
+                        {
+                            CmiWork.RentCount = (CmiList[0].RentCount - intMaterialCountBefore) + intMaterialCount;
+                        }
+                        if (CmiList.Count != 0)
+                        {
+                            CmiWork.RepayCount = CmiList[0].RepayCount;
+                        }
+
+                        // ロック
+                        if (!IoCmi.RowLock(m_ConstructionCode, intMaterialItemCode, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+
+                        if (CmiState == DataRowState.Modified)  // 更新
+                        {
+                            // データ更新
+                            if (!IoCmi.UpdateAction(strSQL, CmiWork, false))
+                            {
+                                m_IoMi.rollback();
+                                m_IoMi.RowLockShare(intMaterialItemCode, false);
+                                IoCmi.rollback();
+                                MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                                return false;
+                            }
+                        }
+                        else if (CmiState == DataRowState.Deleted)  // 削除
+                        {
+                            // データ更新
+                            if (!IoCmi.DeleteAction(strSQL, false))
+                            {
+                                m_IoMi.rollback();
+                                m_IoMi.RowLockShare(intMaterialItemCode, false);
+                                IoCmi.rollback();
+                                MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                                return false;
+                            }
+                        }
+
+                    }
+
+                    // 資材履歴情報
+                    MriWork.MaterialCount = intMaterialCount;
+                    MriWork.RepayPlanDate = CommonMotions.cnvDate(r.Cells[(int)DispColumn.RepayPlanDate].Value);
+                    MriWork.CommentText = CommonMotions.cnvString(r.Cells[(int)DispColumn.CommentText].Value);
+                    MriWork.ConstructionCode = m_ConstructionCode;
+                    MriWork.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                    MriWork.RecKind = 0;
+
+                    strSQL = IoMri.CreatePrimarykeyString(intMaterialItemCode, CommonMotions.cnvDate(strProcessdate));
+
+                    if (MriState == DataRowState.Added) // 資材履歴情報 新規
+                    {
+                        MriWork.MaterialItemCode = intMaterialItemCode;
+                        MriWork.ProcessDate = CommonMotions.cnvDate(strProcessdate);
+                        MriWork.SeqNo = IoMri.SelectMaxMaterialRecordKeyCount(strSQL,false) + 1;
+
+                        MriList.Clear();
+                        MriList.Add(MriWork);
+                        // データ登録
+                        if (!IoMri.InsertAction(MriList, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            IoCmi.rollback();
+                            IoMri.rollback();
+                            MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+                    }
+                    else if (MriState == DataRowState.Modified || MriState == DataRowState.Deleted) // 資材履歴情報 更新or削除
+                    {
+                        // データ確認
+                        strSQL += "and RecKind = 0";
+                        if (!IoMri.SelectAction(strSQL, ref MriList, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            IoCmi.rollback();
+                            MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+
+                        // ロック
+                        if (!IoMri.RowLock(intMaterialItemCode, MriList[0].ProcessDate, MriList[0].SeqNo, false))
+                        {
+                            m_IoMi.rollback();
+                            m_IoMi.RowLockShare(intMaterialItemCode, false);
+                            IoCmi.rollback();
+                            MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                            return false;
+                        }
+
+                        if (MriState == DataRowState.Modified)  // 更新
+                        {
+                            // データ更新
+                            if (!IoMri.UpdateAction(strSQL, MriWork, false))
+                            {
+                                m_IoMi.rollback();
+                                m_IoMi.RowLockShare(intMaterialItemCode, false);
+                                IoCmi.rollback();
+                                IoMri.rollback();
+                                MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                                return false;
+                            }
+                        }
+                        else if (MriState == DataRowState.Deleted)  // 削除
+                        {
+                            // データ更新
+                            if (!IoMri.DeleteAction(strSQL, false))
+                            {
+                                m_IoMi.rollback();
+                                m_IoMi.RowLockShare(intMaterialItemCode, false);
+                                IoCmi.rollback();
+                                IoMri.rollback();
+                                MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                                return false;
+                            }
+                        }
+                    }
+
+                }
+
+                m_IoMi.commit();
+                IoCmi.commit();
+                IoMri.commit();
+
+                //LoadComboBox();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoMri.close();
+                IoMri = null;
+                IoCmi.close();
+                IoCmi = null;
+            }
+            return true;
+        }
+
+        /// <summary>
+        /// グリッド表示
+        /// </summary>
+        /// <returns></returns>
+        private bool DispGridData()
+        {
+            IOConstructionMaterialInfo IoCmi = new IOConstructionMaterialInfo();
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // 貸出日指定
+                string strProcessdate = cmbProcessDate.SelectedValue.ToString() == "0" ?
+                                        DateTime.Now.Date.ToString("yyyy/MM/dd") : cmbProcessDate.SelectedValue.ToString();
+                
+                // グリッドの行を0に戻す
+                dgvMaster.Rows.Clear();
+
+                // SQL作成
+                StringBuilder sql = new StringBuilder();
+                sql.AppendLine("select   Mkm.MaterialKindCode ");
+                sql.AppendLine("        ,Mkm.MaterialKindName ");
+                sql.AppendLine("        ,Mkm.DisplayOrder ");
+                sql.AppendLine("        ,Mim.MaterialItemCode ");
+                sql.AppendLine("        ,Mim.MaterialItemName ");
+                sql.AppendLine("        ,Mim.DisplayOrder ");
+                sql.AppendLine("		,ifnull(Mi.RentCount,0)	as RentCount ");
+                sql.AppendLine("        ,Mri.MaterialCount ");
+                sql.AppendLine("        ,ifnull(DATE_FORMAT(Mri.RepayPlanDate, '%Y/%m/%d'),'') as RepayPlanDate ");
+                sql.AppendLine("        ,ifnull(Mri.CommentText,'') as CommentText ");
+                sql.AppendLine("from MaterialRecordInfo as Mri 	left join MaterialInfo as Mi on Mri.MaterialItemCode = Mi.MaterialItemCode ");
+                sql.AppendLine("								left join (MaterialItemMaster as Mim left join MaterialKindMaster as Mkm on Mim.MaterialKindCode = Mkm.MaterialKindCode) on Mri.MaterialItemCode = Mim.MaterialItemCode ");
+                sql.AppendFormat("where Mri.CONSTRUCTIONCODE = {0} ", ConstructionCode);
+                sql.AppendFormat("and Mri.PROCESSDATE = '{0}' ", strProcessdate);
+                sql.AppendLine("and Mri.RECKIND = 0 ");
+                //sql.AppendLine("order by Mri.PROCESSDATE desc ");
+
+                // データ取得
+                if (!IoCmi.ExecuteReader(sql.ToString(), ref arData)) return false;
+
+                // データ表示
+                int icnt = 0;
+                foreach (object[] work in arData)
+                {
+                    dgvMaster.Rows.Add();
+
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RowState].Value = DataRowState.Unchanged;
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindCode].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialKindCode]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = CommonMotions.cnvString(work[(int)DataColumn.MaterialKindName]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText = CommonMotions.cnvString(work[(int)DataColumn.MaterialKindName]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindDisplayOrder].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialKindDisplayOrder]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemCode].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialItemCode]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemName].Value = CommonMotions.cnvString(work[(int)DataColumn.MaterialItemName]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialItemDisplayOrder].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialItemDisplayOrder]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RentCount].Value = CommonMotions.cnvInt(work[(int)DataColumn.RentCount]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialCount].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialCount]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialCountBefore].Value = CommonMotions.cnvInt(work[(int)DataColumn.MaterialCount]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.RepayPlanDate].Value = CommonMotions.cnvString(work[(int)DataColumn.RepayPlanDate]);
+                    dgvMaster.Rows[icnt].Cells[(int)DispColumn.CommentText].Value = CommonMotions.cnvString(work[(int)DataColumn.CommentText]);
+
+                    icnt++;
+
+                    // 共有ロック
+                    if (!m_IoMi.RowLockShare(CommonMotions.cnvInt(work[(int)DataColumn.MaterialItemCode]), false))
+                    {
+                        return false;
+                    }
+
+                }
+
+                // グリッドを資材種類表示、資材品目表示順にソート
+                dgvMaster.Sort(new RowComparer());
+
+                icnt = 0;
+                foreach (DataGridViewRow work in dgvMaster.Rows)
+                {
+                    string chkString = CommonMotions.cnvString(work.Cells[(int)DispColumn.MaterialKindName].Value);
+
+                    if (!(icnt == 0
+                        || (icnt != 0 && (!chkString.Equals(dgvMaster.Rows[icnt - 1].Cells[(int)DispColumn.MaterialKindName].ToolTipText)))))
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = "";
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText = chkString;
+                    }
+                    icnt++;
+                }
+
+                // №再採番
+                LineReNumbering();
+
+                //// 表示行が足りない場合は追加する
+                //if (dgvMaster.Rows.Count <= CommonDefine.s_MaxInitLineCountMastamente)
+                //{
+                //    int iAddLine = CommonDefine.s_MaxInitLineCountMastamente - dgvMaster.Rows.Count;
+                //    for (int i = 0; i < iAddLine; i++)
+                //    {
+                //        dgvMaster.Rows.Add();
+                //    }
+                //}
+
+                // ボタン制御
+                setButtonEnable();
+                m_bChengeAns = false;
+
+                // 貸出日退避
+                m_ProcessPrev = strProcessdate;
+                //dgvMaster.Rows.Add();
+                //// クリアデータセット
+                //SetRowClearData(dgvMaster.Rows.Count - 1);
+
+                //// 読込時データカウント取得
+                //m_initDataCount = IoCmi.Count;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                IoCmi.close();
+                IoCmi = null;
+            }
+            return true;
+        }
+
+        /// <summary>
+        /// ボタンの表示・非表示制御
+        /// </summary>
+        private void ButtonVisble(Control Parent)
+        {
+            bool bAns = true;
+            if (m_DialogFlg){
+
+                bAns = false;
+            }
+            else
+            {
+                bAns = true;
+            }
+
+            foreach (Control ctrl in Parent.Controls)
+            {
+                if (ctrl.GetType().Equals(typeof(Button)))
+                {
+                    // 終了ボタン以外を制御する
+                    if (ctrl.Name.ToString() != btnEnd.Name.ToString()) ctrl.Visible = bAns;
+                }
+            }
+            // グリッドの読込のみ制御
+            dgvMaster.ReadOnly = m_DialogFlg;
+        }
+
+
+
+        /// <summary>
+        /// 資材選択押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnMaterialSelect_Click(object sender, EventArgs e)
+        {
+            FrmMaterialSelect sel = new FrmMaterialSelect();
+            sel.ShowDialog();
+            if (sel.EndButton == DialogResult.OK)
+            {
+                List<MaterialItemMaster> items = sel.MaterialItemNames;
+                List<MaterialKindMaster> kind = sel.MaterialKindNames;
+                int cnt = 0;
+                int setRow = 0;
+                foreach (MaterialItemMaster item in items)
+                {
+
+                    // 品目調査
+                    DataGridViewRow[] rows = dgvMaster.Rows.Cast<DataGridViewRow>()
+                                                                .Where(x => x.Cells[(int)DispColumn.MaterialKindCode].Value.ToString() == kind[cnt].MaterialKindCode.ToString() && x.Cells[(int)DispColumn.MaterialItemCode].Value.ToString() == item.MaterialItemCode.ToString()).ToArray();
+                    if (rows.Count() > 0)
+                    {
+                        rows[0].Visible = true;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.RowState].Value = DataRowState.Unchanged;
+                    }
+                    else
+                    {
+                        setRow = dgvMaster.Rows.Count == 0 ? 0 : dgvMaster.Rows.Count;
+
+                        // 1行追加
+                        dgvMaster.Rows.Add();
+
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.RowState].Value = DataRowState.Added;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialKindCode].Value = kind[cnt].MaterialKindCode;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialKindName].Value = kind[cnt].MaterialKindName;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialKindName].ToolTipText = kind[cnt].MaterialKindName;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialKindDisplayOrder].Value = kind[cnt].DisplayOrder;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialItemCode].Value = item.MaterialItemCode;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialItemName].Value = item.MaterialItemName;
+                        dgvMaster.Rows[setRow].Cells[(int)DispColumn.MaterialItemDisplayOrder].Value = item.DisplayOrder;
+
+                        List<MaterialInfo> lMi = new List<MaterialInfo>();
+                        m_IoMi.SelectAction(string.Format(" where MaterialItemCode = {0}", item.MaterialItemCode), ref lMi, false);
+                        if (lMi.Count != 0)
+                        {
+                            dgvMaster.Rows[setRow].Cells[(int)DispColumn.RentCount].Value = lMi[0].RentCount;
+                        }
+                        else
+                        {
+                            dgvMaster.Rows[setRow].Cells[(int)DispColumn.RentCount].Value = 0;
+                        }
+                        // 共有ロック
+                        if (!m_IoMi.RowLockShare(item.MaterialItemCode, false))
+                        {
+                            return;
+                        }
+                    }
+
+                    cnt++;
+                }
+
+                // グリッドを資材種類表示、資材品目表示順にソート
+                dgvMaster.Sort(new RowComparer());
+
+                // 資材種類名称設定
+                for (int icnt = dgvMaster.Rows.Count - 1; icnt >= 0; icnt--)
+                {
+                    string chkString = CommonMotions.cnvString(dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText);
+                    if ((icnt - 1) >= 0 &&
+                        dgvMaster.Rows[icnt - 1].Visible == true &&
+                        chkString.Equals(dgvMaster.Rows[icnt - 1].Cells[(int)DispColumn.MaterialKindName].ToolTipText))
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = "";
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText = chkString;
+                    }
+                    else
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = chkString;
+                    }
+                }
+
+                // №再採番
+                LineReNumbering();
+            
+            }
+        }
+
+        /// <summary>
+        /// グリッド最終行での処理
+        /// </summary>
+        private void GridLastLine(ref int SetRow)
+        {
+            // 最終行判定
+            if (dgvMaster.Rows.Count == 0 || dgvMaster.CurrentCell.RowIndex == dgvMaster.Rows.Count - 1)
+            {
+                // 最終列判定
+                if (dgvMaster.Rows.Count == 0 || dgvMaster.CurrentCell.ColumnIndex == (int)DispColumn.DisplayOrder)
+                {
+                    // 1行追加
+                    dgvMaster.Rows.Add();
+                    // クリアデータセット
+                    SetRowClearData(dgvMaster.Rows.Count - 1);
+
+                    SetRow = dgvMaster.Rows.Count - 1;
+                }
+
+            }
+        }
+
+        private void cmbProcessDate_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            if (cmbProcessDate.SelectedValue != null)
+            {
+                string strProcessdate = cmbProcessDate.SelectedValue.ToString() == "0" ?
+                                        DateTime.Now.Date.ToString("yyyy/MM/dd") : cmbProcessDate.SelectedValue.ToString();
+
+                if (m_ProcessPrev != "" && strProcessdate != m_ProcessPrev &&
+                    m_bChengeAns)
+                {
+                    if (MessageBox.Show("データに変更があります、登録せずに対象を変更してよろしいですか？。", "確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                    {
+                        cmbProcessDate.SelectedValue = m_ProcessPrev;
+                        return;
+                    }
+                }
+
+                // グリッドデータ表示
+                DispGridData();
+            }
+        }
+
+        /// <summary>
+        /// 資材履歴押下 
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnMaterialHistory_Click(object sender, EventArgs e)
+        {
+
+            try
+            {
+                FrmMaterialHistory frm = new FrmMaterialHistory();
+
+                List<MaterialInfo> Mi = new List<MaterialInfo>();
+                m_IoMi.SelectAction(string.Format(" where MaterialItemCode = {0}", CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemCode].Value)), ref Mi, false);
+
+                //　遷移先への連携値
+                // パラメータセット
+                frm.MaterialType = CommonMotions.cnvString(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialKindName].ToolTipText);
+                frm.MaterialItemCode = CommonMotions.cnvInt(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemCode].Value);
+                frm.MaterialItem = CommonMotions.cnvString(dgvMaster.CurrentRow.Cells[(int)DispColumn.MaterialItemName].Value);
+
+                if (Mi.Count != 0)
+                {
+                    frm.MaterialCount = CommonMotions.cnvString(Mi[0].MaterialCount);
+                    frm.MaterialAssignableCount = CommonMotions.cnvString(Mi[0].RentCount);
+                }
+                frm.ShowDialog();
+
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+        /// <summary>
+        /// ボタン制御
+        /// </summary>
+        private void setButtonEnable()
+        {
+            try
+            {
+                // 一覧が1行選択されている場合、ボタンを活性にする
+                if (dgvMaster.SelectedCells.Count == 1)
+                {
+                    btnMaterialRelease.Enabled = true;
+                    btnMaterialHistory.Enabled = true;
+                }
+                // 一覧が選択されていない場合、または2行以上選択している場合、ボタンを非活性にする
+                else
+                {
+                    btnMaterialRelease.Enabled = false;
+                    btnMaterialHistory.Enabled = false;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// セルクリック
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellClick(object sender, DataGridViewCellEventArgs e)
+        {
+            setButtonEnable();
+        }
+
+        /// <summary>
+        /// 資材解除押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnMaterialRelease_Click(object sender, EventArgs e)
+        {
+            IOConstructionMaterialInfo cMi = new IOConstructionMaterialInfo();
+            List<ConstructionMaterialInfo> lcMi = new List<ConstructionMaterialInfo>();
+            try
+            {
+                int visibleCnt = 0;
+                foreach (DataGridViewRow work in dgvMaster.Rows)
+                {
+                    if (work.Visible == true) visibleCnt++;
+                }
+
+                if (visibleCnt == 0 || dgvMaster.SelectedCells.Count == 0) return;
+
+                // 該当資材の「工事資材情報」確認
+                string strMateriakItemCode = dgvMaster.Rows[dgvMaster.CurrentRow.Index].Cells[(int)DispColumn.MaterialItemCode].Value.ToString();
+                cMi.connect();
+                cMi.SelectAction(string.Format(" where ConstructionCode = {0} and MaterialItemCode = {1} ", ConstructionCode, strMateriakItemCode), ref lcMi);
+                if (lcMi.Count == 0)
+                {
+                    // 存在しない場合、行削除
+                    m_IoMi.rollback();
+                    dgvMaster.Rows.RemoveAt(dgvMaster.CurrentRow.Index);
+                }
+                else
+                {
+                    // 存在する場合、行非表示
+                    dgvMaster.Rows[dgvMaster.CurrentRow.Index].Cells[(int)DispColumn.RowState].Value = DataRowState.Deleted;
+                    dgvMaster.Rows[dgvMaster.CurrentRow.Index].Visible = false;
+                    dgvMaster.ClearSelection(); 
+                }
+
+                // 資材種類名称設定
+                for (int icnt = dgvMaster.Rows.Count - 1; icnt >= 0; icnt--)
+                {
+                    string chkString = CommonMotions.cnvString(dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText);
+                    if ((icnt - 1) >= 0 &&
+                        dgvMaster.Rows[icnt - 1].Visible == true &&
+                        chkString.Equals(dgvMaster.Rows[icnt - 1].Cells[(int)DispColumn.MaterialKindName].ToolTipText))
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = "";
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].ToolTipText = chkString;
+                    }
+                    else
+                    {
+                        dgvMaster.Rows[icnt].Cells[(int)DispColumn.MaterialKindName].Value = chkString;
+                    }
+                }
+
+                // №再採番
+                LineReNumbering();
+
+                // 変更フラグON
+                m_bChengeAns = true;
+
+                // ボタン制御
+                setButtonEnable();
+            }
+            finally
+            {
+                cMi.close();
+                cMi = null;
+            }
+        }
+
+        /// <summary>
+        /// 資材解除押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private bool DataEntryProcess()
+        {
+            //データチェック
+            if (!DispFeildCheck()) return false;
+
+            if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                    , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return false;
+
+            // 表示行退避
+            int iIndex = dgvMaster.FirstDisplayedScrollingRowIndex;
+
+            // データ登録
+            if (!DataEntry()) return false;
+
+            m_bChengeAns = false;
+
+            return true;
+        }
+    #endregion
+
+
+
+    }
+}
\ No newline at end of file
